﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using WeatherClock.Data;
using WeatherClock.EnableLiveTile;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.ApplicationSettings;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Animation;
using Windows.UI.Xaml.Navigation;

// The Grouped Items Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234231

namespace WeatherClock
{
    /// <summary>
    /// A page that displays a grouped collection of items.
    /// </summary>
    public sealed partial class HubPage : WeatherClock.Common.LayoutAwarePage
    {
        public HubPage()
        {
            this.InitializeComponent();            
        }

        

        /// <summary>
        /// Populates the page with content passed during navigation.  Any saved state is also
        /// provided when recreating a page from a prior session.
        /// </summary>
        /// <param name="navigationParameter">The parameter value passed to
        /// <see cref="Frame.Navigate(Type, Object)"/> when this page was initially requested.
        /// </param>
        /// <param name="pageState">A dictionary of state preserved by this page during an earlier
        /// session.  This will be null the first time a page is visited.</param>
        protected override void LoadState(Object navigationParameter, Dictionary<String, Object> pageState)
        {
            var sampleDataGroups = HubPageDataSource.GetGroups((String)navigationParameter);
            this.DefaultViewModel["Groups"] = sampleDataGroups;
            CreateLiveTile.ShowliveTile(true, "Weather Template");
            var LocationDataGroups = LocationDataSource.GetGroups((String)navigationParameter);
            this.DefaultViewModel["Groups2"] = LocationDataGroups;
                       
        }

        public static Popup settingsPopup = null;
        void Current_Activated(object sender, Windows.UI.Core.WindowActivatedEventArgs e)
        {
            if (e.WindowActivationState == Windows.UI.Core.CoreWindowActivationState.Deactivated)
            {
                settingsPopup.IsOpen = false;
            }
        }

        void settingsPopup_Closed(object sender, object e)
        {
            Window.Current.Activated -= Current_Activated;
        }

        private void LocationPopup()
        {
            settingsPopup = new Popup();
            Rect windowsBounds = Window.Current.Bounds;
            settingsPopup.Closed += settingsPopup_Closed;
            Window.Current.Activated += Current_Activated;


            settingsPopup.IsLightDismissEnabled = true;
            settingsPopup.Height = windowsBounds.Height;
            SelectLocation filter = new SelectLocation();

            var items = LocationDataSource.GetGroups("AllGroups");
            foreach (var item in items)
            {
                filter.itemListView.ItemsSource = item.TopItems;
            }       

            filter.Height = windowsBounds.Height;

            settingsPopup.Child = filter;
            settingsPopup.SetValue(Canvas.LeftProperty, windowsBounds.Width - 370);
            settingsPopup.SetValue(Canvas.TopProperty, 0);
            settingsPopup.IsOpen = true;
            settingsPopup.ChildTransitions = new TransitionCollection();
            settingsPopup.ChildTransitions.Add(new EdgeUIThemeTransition()
            {
                Edge = (SettingsPane.Edge == SettingsEdgeLocation.Right) ?
                       EdgeTransitionLocation.Right :
                       EdgeTransitionLocation.Left
            });
        }

       

        private void itemGridView_ItemClick(object sender, ItemClickEventArgs e)
        {
            if (e == null)
                return;
            HubPageDataItem Data = null;
            Data = e.ClickedItem as HubPageDataItem;
            if (Data != null && Data.UniqueId.StartsWith("More"))
                LocationPopup();

        }
        
    }
}
